SystemOrganization addCategory: #'MC2-Meta-Core-Abstract'!
SystemOrganization addCategory: #'MC2-Meta-Core-Domain'!
SystemOrganization addCategory: #'MC2-Meta-Core-Environment'!
SystemOrganization addCategory: #'MC2-Meta-Core-Meta'!
SystemOrganization addCategory: #'MC2-Meta-Core-Repositories'!
SystemOrganization addCategory: #'MC2-Meta-Core-Slices'!

MDSliceInclusionHandler subclass: #MDMonticelloInclusionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Domain'!

!MDMonticelloInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 21:26'!
handleParent: anElement
	^ slice includesParentElement: anElement! !

!MDMonticelloInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 21:26'!
handleProject: anElement
	^ slice includesProjectElement: anElement! !

!MDMonticelloInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 21:26'!
handleRepositoryAssociation: anElement
	^ slice includesRepositoryAssociationElement: anElement! !

!MDMonticelloInclusionHandler methodsFor: 'handling' stamp: 'jf 10/21/2009 17:19'!
handleSlice: anElement
	^ slice includesSliceElement: anElement! !

!MDMonticelloInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 21:26'!
handleSliceAssociation: anElement
	^ slice includesSliceAssociationElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleBaselineSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleChangeSetSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:08'!
handleDirectoryRepository: anElement
	^ self handleRepository: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleExplicitSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:08'!
handleFileRepository: anElement
	^ self handleRepository: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:08'!
handleMemoryRepository: anElement
	^ self handleRepository: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:10'!
handleMonticelloElement: aMethodElement 
	^ self handleElement: aMethodElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:08'!
handleNetRepository: anElement
	^ self handleRepository: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:23'!
handlePackageInfoSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:11'!
handleParent: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:11'!
handleProject: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleProjectSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:10'!
handleRepository: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:12'!
handleRepositoryAssociation: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:10'!
handleSlice: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:13'!
handleSliceAssociation: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleUnionSlice: anElement 
	^ self handleSlice: anElement! !

MDElementHandler subclass: #MDMonticelloAdaptionHandler
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Domain'!

!MDMonticelloAdaptionHandler class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:05'!
environment: anEnvironment
	^ self basicNew
		initializeWithEnvironment: anEnvironment;
		yourself! !

!MDMonticelloAdaptionHandler class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:18'!
new
	self shouldNotImplement! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:02'!
handleBaselineSlice: anElement
	^ MDBaselineSliceAdaptor 
		on: anElement
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:02'!
handleChangeSetSlice: anElement
	^ MDChangeSetSliceAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:03'!
handleDirectoryRepository: anElement
	^ MDDirectoryRepositoryAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/17/2009 09:37'!
handleElement: anObject
	"There's no reasonable default behavior here."
	
	self error: 'No adaptor available for ', anObject printString.! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:04'!
handleExplicitSlice: anElement
	^ MDExplicitSliceAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:05'!
handleFileRepository: anElement
	^ MDFileRepositoryAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/17/2009 09:39'!
handleMemoryRepository: anElement
	^ MDMemoryRepositoryAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/17/2009 09:38'!
handleNetRepository: anElement
	^ MDNetRepositoryAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:05'!
handlePackageInfoSlice: anElement
	^ MDPackageInfoSliceAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:06'!
handleParent: anElement
	^ MDParentAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:06'!
handleProject: anElement
	^ MDProjectAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:06'!
handleProjectSlice: anElement
	^ MDProjectSliceAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:07'!
handleRepositoryAssociation: anElement
	^ MDRepositoryAssociationAdaptor
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:07'!
handleSliceAssociation: anElement
	^ MDSliceAssociationAdaptor
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:07'!
handleUnionSlice: anElement
	^  MDUnionSliceAdaptor 
		on: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'initialize-release' stamp: 'cwp 10/16/2009 23:00'!
initializeWithEnvironment: anEnvironment
	self initialize.
	environment := anEnvironment! !

MDDomain subclass: #MDMonticelloDomain
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Domain'!

MDMonticelloDomain class
	instanceVariableNames: 'default'!

MDMonticelloDomain class
	instanceVariableNames: 'default'!

!MDMonticelloDomain class methodsFor: 'defaults' stamp: 'jf 1/8/2010 15:05'!
default
	^ default ifNil: [default := self new]! !

!MDMonticelloDomain class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:07'!
environment: anEnvironment
	^ self basicNew
		initializeWithEnvironment: anEnvironment;
		yourself! !

!MDMonticelloDomain class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:07'!
new
	^ self environment: MDEnvironment default! !

!MDMonticelloDomain class methodsFor: 'accessing' stamp: 'cwp 6/15/2008 20:41'!
type
	^ #monticello! !

!MDMonticelloDomain methodsFor: 'public' stamp: 'cwp 10/16/2009 23:00'!
adapt: anElement
	^ anElement handleWith: (MDMonticelloAdaptionHandler environment: environment)! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'jf 10/4/2009 19:52'!
adaptorForBaselineSliceElement: anElement 
	^ MDBaselineSliceAdaptor 
		on: anElement
		inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 9/11/2009 20:01'!
adaptorForChangeSetSliceElement: anElement
	^ MDChangeSetSliceAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 10/16/2009 16:28'!
adaptorForDirectoryRepositoryElement: anElement
	^ MDDirectoryRepositoryAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 9/11/2009 13:55'!
adaptorForExplicitSliceElement: anElement
	^ MDExplicitSliceAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 10/16/2009 16:28'!
adaptorForFileRepositoryElement: anElement
	^ MDFileRepositoryAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 9/11/2009 20:17'!
adaptorForPackageInfoSliceElement: anElement
	^ MDPackageInfoSliceAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 8/18/2009 22:05'!
adaptorForParentElement: anElement
	^ MDParentAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 8/18/2009 22:05'!
adaptorForProjectElement: anElement
	^ MDProjectAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 9/11/2009 20:58'!
adaptorForProjectSliceElement: anElement
	^ MDProjectSliceAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'jf 9/8/2009 17:20'!
adaptorForRepositoryAssociationElement: anElement
	^ MDRepositoryAssociationAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'jf 9/6/2009 13:50'!
adaptorForSliceAssociationElement: anElement
	^ MDSliceAssociationAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'adapting' stamp: 'cwp 9/11/2009 19:55'!
adaptorForUnionSliceElement: anElement
	^ MDUnionSliceAdaptor on: anElement inEnvironment: environment! !

!MDMonticelloDomain methodsFor: 'initializing' stamp: 'jf 1/8/2010 15:03'!
initializeWithEnvironment: anEnvironment
	self initialize.
	environment := anEnvironment! !

!MDMonticelloDomain methodsFor: 'testing' stamp: 'cwp 5/26/2008 22:04'!
name
	^ #monticello! !

MDSlice subclass: #MDMonticelloSlice
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Meta'!

MDMonticelloSlice subclass: #MDBaselineSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Meta'!

!MDBaselineSlice class methodsFor: 'converting' stamp: 'jf 10/4/2009 19:50'!
elementClass
	^ MDBaselineSliceElement! !

!MDBaselineSlice methodsFor: 'enumerating' stamp: 'jf 9/6/2009 12:58'!
elementsDo: aBlock
	project slices do: 
		[:slice | aBlock value: (MDParentElement id: slice id)]! !

!MDBaselineSlice methodsFor: 'testing' stamp: 'jf 9/6/2009 13:03'!
includesParentElement: anElement
	^ project slices anySatisfy: [:slice | slice id = anElement id]! !

!MDBaselineSlice methodsFor: 'accessing' stamp: 'jf 11/8/2009 20:55'!
name
	^ project name, '/baseline'! !

!MDMonticelloSlice class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 22:14'!
id: aHashstamp project: aProject
	^ self basicNew initializeWithId: aHashstamp project: aProject! !

!MDMonticelloSlice class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 22:15'!
on: aProject
	^ self id: MDHashstamp new project: aProject! !

!MDMonticelloSlice methodsFor: 'testing' stamp: 'cwp 10/17/2009 22:51'!
includes: anElement 
	^ (MDMonticelloInclusionHandler on: self) handle: anElement! !

!MDMonticelloSlice methodsFor: 'initialize-release' stamp: 'cwp 1/18/2010 22:28'!
initializeWithId: aHashstamp project: aProject
	self initializeWithId: aHashstamp.
	project := aProject! !

!MDMonticelloSlice methodsFor: 'accessing' stamp: 'cwp 11/10/2008 06:22'!
name
	self subclassResponsibility! !

!MDMonticelloSlice methodsFor: 'accessing' stamp: 'jf 10/17/2009 00:58'!
project
	^ project! !

MDMonticelloSlice subclass: #MDProjectSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Meta'!

!MDProjectSlice class methodsFor: 'converting' stamp: 'cwp 9/12/2009 12:30'!
elementClass
	^ MDProjectSliceElement! !

!MDProjectSlice methodsFor: 'accessing' stamp: 'jf 9/20/2009 22:20'!
elementsDo: aBlock
	aBlock value: (MDProjectElement for: project).
	project slices do: [:ea |
		aBlock value: ea asElement.
		aBlock value: (MDSliceAssociationElement forSlice: ea inProject: project)]
! !

!MDProjectSlice methodsFor: 'testing' stamp: 'cwp 11/11/2008 14:51'!
includesProjectElement: anElement
	^ project id = anElement id! !

!MDProjectSlice methodsFor: 'testing' stamp: 'jf 9/8/2009 17:03'!
includesRepositoryAssociationElement: anElement
	^ project id = anElement projectId! !

!MDProjectSlice methodsFor: 'testing' stamp: 'jf 9/6/2009 13:47'!
includesSliceAssociationElement: anElement
	^ project id = anElement projectId! !

!MDProjectSlice methodsFor: 'testing' stamp: 'jf 9/6/2009 13:06'!
includesSliceElement: anElement
	^ project slices anySatisfy: [:slice | slice id = anElement id]! !

!MDProjectSlice methodsFor: 'accessing' stamp: 'jf 11/8/2009 20:56'!
name
	^ project name, '/project'! !

!MDSlice methodsFor: '*mc2-meta-core-dispatch' stamp: 'cwp 10/16/2009 22:24'!
includesParentElement: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-meta-core-dispatch' stamp: 'cwp 10/16/2009 22:24'!
includesProjectElement: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-meta-core-dispatch' stamp: 'cwp 10/16/2009 22:24'!
includesRepositoryAssociationElement: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-meta-core-dispatch' stamp: 'cwp 10/16/2009 22:24'!
includesRepositoryElement: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-meta-core-dispatch' stamp: 'cwp 10/16/2009 22:24'!
includesSliceAssociationElement: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-meta-core-dispatch' stamp: 'cwp 10/16/2009 22:24'!
includesSliceElement: anElement
	^ false! !

MDElement subclass: #MDMonticelloElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Abstract'!

MDMonticelloElement subclass: #MDEnvironmentObjectElement
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Abstract'!

!MDEnvironmentObjectElement class methodsFor: 'instance creation' stamp: 'jf 9/8/2009 17:04'!
for: aVersionedObject
	^ self id: aVersionedObject id! !

!MDEnvironmentObjectElement class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 14:57'!
id: aHashstamp
	^ self basicNew
		initializeWithId: aHashstamp;
		yourself! !

!MDEnvironmentObjectElement class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:18'!
new
	self shouldNotImplement! !

!MDEnvironmentObjectElement methodsFor: 'comparing' stamp: 'jf 9/8/2009 16:50'!
= other 
	^ self species = other species 
		and: [id = other id] ! !

!MDEnvironmentObjectElement methodsFor: 'printing' stamp: 'cwp 9/11/2009 13:22'!
displayClassName
	^ self className allButFirst: 2! !

!MDEnvironmentObjectElement methodsFor: 'comparing' stamp: 'cwp 9/11/2009 13:21'!
hash
	^ ByteArray 
		hashBytes: id 
		startingWith: self species hash! !

!MDEnvironmentObjectElement methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:48'!
id
	^ id! !

!MDEnvironmentObjectElement methodsFor: 'initialize-release' stamp: 'jf 1/8/2010 14:55'!
initializeWithId: aHashstamp
	self initialize.
	id := aHashstamp! !

MDEnvironmentObjectElement subclass: #MDParentElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDParentElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain
	^ aDomain adaptorForParentElement: self! !

!MDParentElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:30'!
handleWith: anObject
	^ anObject handleParent: self! !

MDEnvironmentObjectElement subclass: #MDProjectElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDProjectElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:55'!
adaptedFor: aDomain
	^ aDomain adaptorForProjectElement: self! !

!MDProjectElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:36'!
handleWith: anObject
	^ anObject handleProject: self! !

!MDProjectElement methodsFor: 'comparing' stamp: 'cwp 6/1/2008 23:09'!
hash
	^ id hash! !

MDEnvironmentObjectElement subclass: #MDRepositoryElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Repositories'!

MDRepositoryElement subclass: #MDMemoryRepositoryElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Repositories'!

!MDMemoryRepositoryElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:32'!
handleWith: anObject
	^ anObject handleMemoryRepository: self! !

MDEnvironmentObjectElement subclass: #MDSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

MDSliceElement subclass: #MDBaselineSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Meta'!

!MDBaselineSliceElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain 
	^ aDomain adaptorForBaselineSliceElement: self! !

!MDBaselineSliceElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:32'!
handleWith: anObject
	^ anObject handleBaselineSlice: self! !

MDSliceElement subclass: #MDExplicitSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

!MDExplicitSliceElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain
	^ aDomain adaptorForExplicitSliceElement: self! !

!MDExplicitSliceElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:33'!
handleWith: anObject
	^ anObject handleExplicitSlice: self! !

MDSliceElement subclass: #MDProjectSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Meta'!

!MDProjectSliceElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain 
	^ aDomain adaptorForProjectSliceElement: self! !

!MDProjectSliceElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:34'!
handleWith: anObject
	^ anObject handleProjectSlice: self! !

MDSliceElement subclass: #MDUnionSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

!MDUnionSliceElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain 
	^ aDomain adaptorForUnionSliceElement: self! !

!MDUnionSliceElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:34'!
handleWith: anObject
	^ anObject handleUnionSlice: self! !

!MDMonticelloElement methodsFor: 'adapting' stamp: 'cwp 5/26/2008 21:50'!
domain
	^ #monticello! !

MDMonticelloElement subclass: #MDRepositoryAssociationElement
	instanceVariableNames: 'projectId repositoryId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDRepositoryAssociationElement class methodsFor: 'instance creation' stamp: 'jf 9/8/2009 16:39'!
forRepository: aRepository inProject: aProject
	^ self projectId: aProject id repositoryId: aRepository id! !

!MDRepositoryAssociationElement class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:14'!
new
	self shouldNotImplement! !

!MDRepositoryAssociationElement class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:11'!
projectId: pHashstamp repositoryId: rHashstamp
	^ self basicNew
		initializeWithProjectId: pHashstamp repositoryId: rHashstamp;
		yourself! !

!MDRepositoryAssociationElement methodsFor: 'comparing' stamp: 'jf 9/8/2009 16:39'!
= other 
	^ self species = other species 
		and: [repositoryId = other repositoryId] 
		and: [projectId = other projectId]! !

!MDRepositoryAssociationElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:55'!
adaptedFor: aDomain
	^ aDomain adaptorForRepositoryAssociationElement: self! !

!MDRepositoryAssociationElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:34'!
handleWith: anObject
	^ anObject handleRepositoryAssociation: self! !

!MDRepositoryAssociationElement methodsFor: 'testing' stamp: 'jf 9/8/2009 16:39'!
hash
	^ ByteArray 
		hashBytes: repositoryId 
		startingWith: (ByteArray 
						hashBytes: projectId 
						startingWith: self species hash)! !

!MDRepositoryAssociationElement methodsFor: 'initialization' stamp: 'jf 1/8/2010 15:10'!
initializeWithProjectId: pHashstamp repositoryId: rHashstamp
	self initialize.
	projectId := pHashstamp.
	repositoryId := rHashstamp.! !

!MDRepositoryAssociationElement methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:39'!
projectId
	^ projectId! !

!MDRepositoryAssociationElement methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:39'!
repositoryId
	^ repositoryId! !

MDMonticelloElement subclass: #MDSliceAssociationElement
	instanceVariableNames: 'projectId sliceId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDSliceAssociationElement class methodsFor: 'instance creation' stamp: 'jf 9/6/2009 12:46'!
forSlice: aSlice inProject: aProject 
	^ self 
		projectId: aProject id
		sliceId: aSlice id! !

!MDSliceAssociationElement class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:15'!
new
	self shouldNotImplement! !

!MDSliceAssociationElement class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:15'!
projectId: projectId sliceId: sliceId 
	^ self basicNew
		initializeWithProjectId: projectId sliceId: sliceId;
		yourself! !

!MDSliceAssociationElement methodsFor: 'comparing' stamp: 'jf 9/6/2009 12:46'!
= other 
	^ self species = other species 
		and: [sliceId = other sliceId] 
		and: [projectId = other projectId]! !

!MDSliceAssociationElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain
	^ aDomain adaptorForSliceAssociationElement: self! !

!MDSliceAssociationElement methodsFor: 'printing' stamp: 'jf 9/6/2009 12:46'!
displayClassName
	^ self className allButFirst: 2! !

!MDSliceAssociationElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:34'!
handleWith: anObject
	^ anObject handleSliceAssociation: self! !

!MDSliceAssociationElement methodsFor: 'comparing' stamp: 'jf 9/6/2009 12:46'!
hash
	^ ByteArray 
		hashBytes: sliceId 
		startingWith: (ByteArray 
						hashBytes: projectId 
						startingWith: self species hash)! !

!MDSliceAssociationElement methodsFor: 'initialization' stamp: 'jf 1/8/2010 15:14'!
initializeWithProjectId: pHashstamp sliceId: sHashstamp
	self initialize.
	projectId := pHashstamp.
	sliceId := sHashstamp! !

!MDSliceAssociationElement methodsFor: 'accessing' stamp: 'jf 9/6/2009 12:46'!
projectId
	^ projectId! !

!MDSliceAssociationElement methodsFor: 'accessing' stamp: 'jf 9/6/2009 12:46'!
sliceId
	^ sliceId! !

MDObject subclass: #MDMonticelloAdaptor
	instanceVariableNames: 'environment element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Abstract'!

!MDMonticelloAdaptor class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:18'!
new
	self shouldNotImplement! !

!MDMonticelloAdaptor class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 14:51'!
on: anElement inEnvironment: anEnvironment
	^ self basicNew
		initializeWithElement: anElement environment: anEnvironment;
		yourself! !

!MDMonticelloAdaptor methodsFor: 'accessing' stamp: 'jf 9/26/2009 01:54'!
environment
	^ environment! !

!MDMonticelloAdaptor methodsFor: 'initialize-release' stamp: 'jf 1/8/2010 14:51'!
initializeWithElement: anElement environment: anEnvironment
	self initialize.
	element := anElement.
	environment := anEnvironment! !

!MDMonticelloAdaptor methodsFor: 'public' stamp: 'cwp 3/4/2008 22:36'!
isLoadable: properties
	self subclassResponsibility! !

!MDMonticelloAdaptor methodsFor: 'public' stamp: 'cwp 3/4/2008 23:29'!
isPresent
	self subclassResponsibility! !

!MDMonticelloAdaptor methodsFor: 'public' stamp: 'cwp 3/4/2008 22:36'!
isUpToDate: properties
	self subclassResponsibility ! !

!MDMonticelloAdaptor methodsFor: 'public' stamp: 'cwp 3/4/2008 22:36'!
load: properties
	self subclassResponsibility! !

!MDMonticelloAdaptor methodsFor: 'public' stamp: 'cwp 3/4/2008 22:37'!
merge: properties into: otherProperties onFailure: aBlock
	self subclassResponsibility! !

!MDMonticelloAdaptor methodsFor: 'public' stamp: 'cwp 3/4/2008 22:37'!
remove
	self subclassResponsibility ! !

!MDMonticelloAdaptor methodsFor: 'public' stamp: 'cwp 3/4/2008 22:38'!
update: properties
	self subclassResponsibility! !

MDMonticelloAdaptor subclass: #MDParentAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDParentAdaptor methodsFor: 'private' stamp: 'jf 9/6/2009 13:37'!
historian
	^ environment historianWithId: element id! !

!MDParentAdaptor methodsFor: 'public' stamp: 'jf 9/6/2009 13:39'!
isLoadable: properties
	^ self historian notNil! !

!MDParentAdaptor methodsFor: 'public' stamp: 'jf 9/6/2009 13:39'!
isPresent
	^ (environment 
		historianWithId: element id
		ifAbsent: [ ^ false ]) parents isEmpty not! !

!MDParentAdaptor methodsFor: 'public' stamp: 'cwp 6/1/2008 20:32'!
isUpToDate: properties
	^ self historian parents first = properties memoref! !

!MDParentAdaptor methodsFor: 'public' stamp: 'jf 9/6/2009 13:40'!
load: properties
	| memo |
	memo := environment store get: properties memoref.
	environment load: memo! !

!MDParentAdaptor methodsFor: 'public' stamp: 'cwp 1/22/2010 21:05'!
remove
	self historian clearAncestry! !

!MDParentAdaptor methodsFor: 'public' stamp: 'cwp 6/1/2008 12:05'!
update: properties
	^ properties 
		memoref: self historian parents first;
		yourself! !

MDMonticelloAdaptor subclass: #MDProjectAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDProjectAdaptor methodsFor: 'testing' stamp: 'cwp 5/27/2008 21:43'!
isLoadable: properties
	"Always loadable"
	
	^ true! !

!MDProjectAdaptor methodsFor: 'testing' stamp: 'cwp 8/18/2009 21:53'!
isPresent
	^ environment includesProjectId: element id! !

!MDProjectAdaptor methodsFor: 'testing' stamp: 'cwp 5/27/2008 21:52'!
isUpToDate: properties
	^ self project name = properties name! !

!MDProjectAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2010 22:31'!
load: properties 
	| project |
	self isPresent 
		ifTrue: [ self project name: properties name ]
		ifFalse: 
			[project := MDProject id: element id name: properties name.
			environment addProject: project ]! !

!MDProjectAdaptor methodsFor: 'accessing' stamp: 'cwp 8/18/2009 21:58'!
project
	^ environment projectWithId: element id! !

!MDProjectAdaptor methodsFor: 'public' stamp: 'cwp 8/18/2009 21:58'!
remove
	| project |
	project := self project.
	environment removeProjectId: element id.
! !

!MDProjectAdaptor methodsFor: 'public' stamp: 'cwp 5/27/2008 21:55'!
update: properties
	properties name: self project name! !

MDMonticelloAdaptor subclass: #MDProjectPartAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDProjectPartAdaptor methodsFor: 'accessing' stamp: 'cwp 8/18/2009 22:13'!
project
	^ environment projectWithId: element projectId! !

MDProjectPartAdaptor subclass: #MDRepositoryAssociationAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDRepositoryAssociationAdaptor methodsFor: 'testing' stamp: 'jf 9/8/2009 18:03'!
isLoadable: properties
	^ (environment includesProjectId: element projectId)
		and: [environment includesRepositoryId: element repositoryId]! !

!MDRepositoryAssociationAdaptor methodsFor: 'public' stamp: 'jf 9/8/2009 16:40'!
isPresent
	| project |
	project := self project.
	^ project 
		ifNil: [false]
		ifNotNil: [project repositories anySatisfy: [:ea | ea id = element repositoryId]]! !

!MDRepositoryAssociationAdaptor methodsFor: 'public' stamp: 'jf 9/8/2009 17:40'!
isUpToDate: properties
	^ true! !

!MDRepositoryAssociationAdaptor methodsFor: 'public' stamp: 'jf 9/8/2009 17:44'!
load: properties
	self project addRepository: self repository! !

!MDRepositoryAssociationAdaptor methodsFor: 'public' stamp: 'jf 9/8/2009 17:45'!
remove
	self project removeRepository: self repository! !

!MDRepositoryAssociationAdaptor methodsFor: 'private' stamp: 'jf 9/8/2009 18:05'!
repository
	^ environment repositoryWithId: element repositoryId! !

!MDRepositoryAssociationAdaptor methodsFor: 'public' stamp: 'jf 9/8/2009 17:46'!
update: properties
	"Nothing to update"! !

MDProjectPartAdaptor subclass: #MDSliceAssociationAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDSliceAssociationAdaptor methodsFor: 'testing' stamp: 'jf 9/8/2009 18:05'!
isLoadable: properties
	^ (environment includesProjectId: element projectId)
		and: [environment includesSliceId: element sliceId]! !

!MDSliceAssociationAdaptor methodsFor: 'testing' stamp: 'jf 9/6/2009 13:11'!
isPresent
	| project |
	project := self project.
	^ project
		ifNil: [false]
		ifNotNil: [project slices anySatisfy: [:ea | ea id = element sliceId]]! !

!MDSliceAssociationAdaptor methodsFor: 'testing' stamp: 'jf 9/6/2009 14:37'!
isUpToDate: properties
	^ true! !

!MDSliceAssociationAdaptor methodsFor: 'public' stamp: 'jf 9/6/2009 14:43'!
load: properties
	self project addSlice: self slice! !

!MDSliceAssociationAdaptor methodsFor: 'public' stamp: 'jf 9/6/2009 14:44'!
remove
	self project removeSlice: self slice! !

!MDSliceAssociationAdaptor methodsFor: 'accessing' stamp: 'jf 9/8/2009 18:06'!
slice
	^ environment sliceWithId: element sliceId! !

!MDSliceAssociationAdaptor methodsFor: 'public' stamp: 'jf 9/6/2009 14:44'!
update: properties
	"Nothing to update"! !

MDMonticelloAdaptor subclass: #MDRepositoryAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Repositories'!

MDRepositoryAdaptor subclass: #MDMemoryRepositoryAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Repositories'!

!MDMemoryRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/18/2009 21:37'!
createRepository: properties
	^ MDMemoryRepository 
		id: element id 
		name: properties name! !

!MDMemoryRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/18/2009 23:01'!
isUpToDate: properties
	| repository |
	repository := self repositoryIfAbsent: [^ false].
	^ repository name = properties name! !

!MDMemoryRepositoryAdaptor methodsFor: 'private' stamp: 'cwp 10/21/2009 23:40'!
modify: aRepository with: properties
	aRepository name: properties name! !

!MDMemoryRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/21/2009 20:35'!
update: properties 
	| repository |
	repository := self repositoryIfAbsent: [ ^ properties ].
	properties name: repository name.
	^ properties! !

!MDRepositoryAdaptor methodsFor: 'testing' stamp: 'jf 9/8/2009 17:22'!
isLoadable: properties
	^ true! !

!MDRepositoryAdaptor methodsFor: 'public' stamp: 'jf 9/8/2009 17:22'!
isPresent
	^ environment includesRepositoryId: element id! !

!MDRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/21/2009 23:31'!
load: properties
	| repository |
	repository := self repositoryIfAbsent: [self createRepository: properties].
	self modify: repository with: properties.
	environment addRepository: repository.! !

!MDRepositoryAdaptor methodsFor: 'private' stamp: 'cwp 10/21/2009 23:31'!
modify: aRepository with: properties
	self subclassResponsibility! !

!MDRepositoryAdaptor methodsFor: 'public' stamp: 'jf 9/8/2009 18:57'!
remove
	| repository |
	repository := self repositoryIfAbsent: [^ self].
	environment removeRepositoryId: repository id! !

!MDRepositoryAdaptor methodsFor: 'private' stamp: 'jf 9/8/2009 17:25'!
repositoryIfAbsent: aBlock
	^ environment repositories
		detect: [:ea | ea id = element id]
		ifNone: aBlock! !

MDMonticelloAdaptor subclass: #MDSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

MDSliceAdaptor subclass: #MDExplicitSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

!MDExplicitSliceAdaptor methodsFor: 'private' stamp: 'cwp 1/18/2010 22:04'!
createSlice: properties
	^ MDExplicitSlice
		id: element id
		name: properties name
		elements: properties elements! !

!MDExplicitSliceAdaptor methodsFor: 'private' stamp: 'jf 10/21/2009 15:08'!
update: properties fromSlice: aSlice
	super update: properties fromSlice: aSlice.
	properties elements: aSlice elements! !

MDSliceAdaptor subclass: #MDMonticelloSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Meta'!

MDMonticelloSliceAdaptor subclass: #MDBaselineSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Meta'!

!MDBaselineSliceAdaptor methodsFor: 'private' stamp: 'jf 10/16/2009 23:17'!
createSlice: properties
	^ MDBaselineSlice
		id: element id
		project: (self environment projectWithId: properties projectId)! !

!MDMonticelloSliceAdaptor methodsFor: 'testing' stamp: 'jf 9/26/2009 02:01'!
isLoadable: properties
	^ (super isLoadable: properties) and: [
		environment includesProjectId: properties projectId ]! !

!MDMonticelloSliceAdaptor methodsFor: 'private' stamp: 'jf 11/8/2009 21:02'!
update: properties fromSlice: aSlice
	properties projectId: aSlice project id! !

MDMonticelloSliceAdaptor subclass: #MDProjectSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Meta'!

!MDProjectSliceAdaptor methodsFor: 'private' stamp: 'jf 10/16/2009 23:10'!
createSlice: properties
	^ MDProjectSlice
		id: element id
		project: (self environment projectWithId: properties projectId)! !

!MDSliceAdaptor methodsFor: 'private' stamp: 'jf 10/16/2009 22:52'!
createSlice: properties
	self subclassResponsibility! !

!MDSliceAdaptor methodsFor: 'testing' stamp: 'jf 9/6/2009 13:13'!
isLoadable: properties
	^ true! !

!MDSliceAdaptor methodsFor: 'testing' stamp: 'jf 9/6/2009 13:14'!
isPresent
	^ environment includesSliceId: element id! !

!MDSliceAdaptor methodsFor: 'testing' stamp: 'jf 10/21/2009 14:58'!
isUpToDate: properties
	^ self properties = properties! !

!MDSliceAdaptor methodsFor: 'public' stamp: 'jf 10/16/2009 16:15'!
load: properties
	| slice |
	slice := self sliceIfAbsent: [self createSlice: properties].
	environment addSlice: slice.! !

!MDSliceAdaptor methodsFor: 'private' stamp: 'jf 10/21/2009 14:58'!
properties
	^ self update: MDPropertyDictionary new! !

!MDSliceAdaptor methodsFor: 'public' stamp: 'jf 9/6/2009 13:28'!
remove
	| slice |
	slice := self sliceIfAbsent: [^ self].
	environment removeSliceId: slice id! !

!MDSliceAdaptor methodsFor: 'private' stamp: 'jf 9/6/2009 13:15'!
sliceIfAbsent: aBlock
	^ environment slices 
		detect: [:ea | ea id = element id] 
		ifNone: aBlock! !

!MDSliceAdaptor methodsFor: 'public' stamp: 'jf 10/21/2009 15:05'!
update: properties
	| slice |
	slice := self sliceIfAbsent: [^ properties].
	self update: properties fromSlice: slice.
	^ properties! !

!MDSliceAdaptor methodsFor: 'private' stamp: 'jf 10/21/2009 15:14'!
update: properties fromSlice: aSlice
	properties name: aSlice name! !

MDSliceAdaptor subclass: #MDUnionSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

!MDUnionSliceAdaptor methodsFor: 'private' stamp: 'cwp 1/18/2010 22:20'!
createSlice: properties
	^ MDUnionSlice
		id: element id
		name: properties name
		slices: (properties sliceIds collect: [:ea | self environment sliceWithId: ea])! !

!MDUnionSliceAdaptor methodsFor: 'testing' stamp: 'jf 10/17/2009 00:46'!
isLoadable: properties
	^ (super isLoadable: properties) and: [
		properties sliceIds allSatisfy: [:each |
			self environment includesSliceId: each] ]! !

!MDUnionSliceAdaptor methodsFor: 'private' stamp: 'jf 10/21/2009 15:08'!
update: properties fromSlice: aSlice
	super	update: properties fromSlice: aSlice.
	properties sliceIds: (aSlice slices collect: [:ea | ea id])! !
